<template>
    <div class="modal-background" id="outside_modal">
        <div class="new-study-wrapper" id="in_modal">
            <div class="headline">Create a new study</div>
            <div class="new-study-grid">
                <div class="headline sub">Study details</div>
                <div class="headline sub">Data files</div>
                <div class="new-study-fields">
                    <span>Study Name:</span><input type="text" pattern="[a-zA-Z0-9_ ]*" placeholder="My awesome study" id="study_name"/><div>{{ alerts.name }}</div>
                    <span>Study ID:</span><input type="text" pattern="[a-zA-Z0-9_ ]*" class="lowercase" placeholder="awesome_study" id="study_id"/><div>{{ alerts.id }}</div>
                    <span class="span-grid">
                        The study ID is used to identify your study in the database. It must be unique. Both the study name and ID
                        must only consist of alphanumerical symbols, spaces and underscores.
                    </span>
                    <span>Study Author(s):</span><input type="text" pattern="[\p{L}\p{M},\.\- ]*" placeholder="Author1, Author2" id="study_author"/><div>{{ alerts.author }}</div>
                    <span class="span-grid">Please supply a comma-separated list.</span>
                    <span>Method(s):</span><select required id="study_type" multiple>
                        <option value="unknown">No information / unknown</option>
                        <option value="nmr">NMR</option>
                        <option value="lc-ms">LC-MS</option>
                        <option value="gc-ms">GC-MS</option>
                        <option value="other">Other</option>
                    </select><div>{{ alerts.method }}</div>
                    <span>Biospecimen:</span><select required id="study_specimen" multiple>
                        <option value="unknown">No information / unknown</option>
                        <option value="blood">Blood</option>
                        <option value="urine">Urine</option>
                        <option value="feces">Feces</option>
                        <option value="csf">Cerebral Spinal Fluid</option>
                        <option value="serum">Serum</option>
                        <option value="plasma">Plasma</option>
                        <option value="other">Other</option>
                    </select><div>{{ alerts.specimen }}</div>
                    <span class="span-grid">Select multiple options by holding down the CTRL key. Please select 'other' if the provided choices are not suitable for your study.</span>
                    <span>Visibility:</span><select required id="study_visibility">
                        <option selected value="private">Private</option>
                        <option value="public">Public</option>
                    </select><div>{{ alerts.visibility }}</div>
                    <span class="span-grid">You can grant access to private studies to your peers later on.</span>
                    <span>Date:</span><input type="text" pattern="[0-9_\- ]*" placeholder="2001-2024" id="study_date"/><div>{{ alerts.date }}</div>
                    <span class="span-grid">You can either provide a single year or a span of years.</span>
                </div>
                <div class="new-study-fields-right">
                    <span class="span-grid" style="font-size: var(--fs-small); color: var(--color-text)">Raw/experimental data can be added to the study after initial creation.</span>
                    <span>Concentration data:</span><input type="file" @change="setConcentrationFile"/>
                    <div style="display: flex; align-items: center; margin-left: 8px;" v-show="conc_file">
                        <b>&nbsp;Transpose:</b>&nbsp;
                        <input type="checkbox" v-model="conc_transpose" style="accent-color: var(--color-head)"/>
                    </div>
                    <span class="span-grid">Accepted file formats: CSV, TSV, XLS, XLSX. You can also add this data later on.</span>
                    <span>Phenotype data:</span><input type="file" @change="setPhenotypeFile"/>
                    <div style="display: flex; align-items: center; margin-left: 8px;" v-show="phenotype_file">
                        <b>&nbsp;Transpose:</b>&nbsp;
                        <input type="checkbox" v-model="pheno_transpose" style="accent-color: var(--color-head)"/>
                    </div>
                    <span class="span-grid">Accepted file formats: CSV, TSV, XLS, XLSX. You can also add this data later on.</span>
                    <span class="span-grid">Please check "transpose" if you use <b>one column per patient</b>.
                        If you use one row per patient, you do not need to check it. Refer to the help section for more information and file format specifications.</span>
                    <span class="span-grid-larger">Metadata can either be provided as a file, or right here:</span>
                    <span>Metadata file:</span><input type="file" @change="setMetadataFile" title=""/><div>{{ alerts.metafile }}</div>
                    <span class="span-grid">Accepted file formats: JSON, YAML.</span>
                    
                    <div class="rule-grid" style="grid-column: 1/4; max-height: 15rem;">
                        <div class="rule-item">
                            <b>Internal Key</b>
                            <b>Metadata Descriptor</b>
                            <b>Value</b>
                            <div style="width: 48px; height: 48px;"/>
                        </div>
                        <div v-for="rule of metadata" :key="rule.key" class="rule-item">
                            <div>{{ rule.key }}</div>
                            <div>{{ rule.name }}</div>
                            <div>{{ rule.value }}</div>
                            <Icon icon="mdi:cancel-bold" width="30" height="30" color="var(--color-primary)" class="icon" @click="removeMetadata(rule.key)"/>
                        </div>
                        <div class="rule-item" v-if="currently_adding_metadata">
                            <input type="text" placeholder="my_key" id="metadata_key">
                            <input type="text" placeholder="My awesome key" id="metadata_name">
                            <input type="text" placeholder="42" id="metadata_value">
                            <Icon icon="mdi:tick" width="30" height="30" color="green" class="icon" @click="addMetadata"/>
                        </div>
                        <div class="rule-grid-add" v-if="!currently_adding_metadata" @click="currently_adding_metadata = true">+</div>
                    </div>
                </div>
            </div>
            <div class="buttons">
                <button @click="createThisStudy">Submit</button>
                <button @click="emit('close-modal')">Cancel</button>
                <VueSpinnerGears v-if="loading" size="24" color="var(--color-primary)"></VueSpinnerGears>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">
import type { MetadataObject, StudyData, StudyFiles } from '@/stores/studies';
import { Icon } from '@iconify/vue';
import { ref } from 'vue';
import { type ParseParameters } from '@/modules/study_module';
import { VueSpinnerGears } from 'vue3-spinners';

const emit = defineEmits<{
    'close-modal': [],
    'create-study': [study_data: StudyData, study_files: StudyFiles, study_params: ParseParameters],
    'upload-raw-data': [data: File|null],
}>();

const props = defineProps<{
    loading: boolean,
}>();

const getThisStudy = (): StudyData => {
    let return_obj: StudyData = {
        study_id: (document.getElementById('study_id') as HTMLInputElement)?.value,
        study_name: (document.getElementById('study_name') as HTMLInputElement)?.value,
        study_date: (document.getElementById('study_date') as HTMLInputElement)?.value,
        study_visibility: (document.getElementById('study_visibility') as HTMLInputElement)?.value,
        study_author: (document.getElementById('study_author') as HTMLInputElement)?.value,
        study_members: {},
        study_type: "",
        study_specimen: "",
        study_metadata: {}
    }
    let study_types = (document.getElementById('study_type') as HTMLSelectElement)?.selectedOptions;
    if (study_types.length >= 2) {
        return_obj.study_type = "multiple";
        for (let n=0; n<study_types.length; n++) {
            metadata.value[`internal_study_type_${n+1}`] = {
                key: `internal_study_type_${n+1}`,
                name: `Analytical Method ${n+1}`,
                value: study_types[n].value
            }
        }
    } else {
        return_obj.study_type = (document.getElementById('study_type') as HTMLInputElement)?.value;
    }
    let study_spec = (document.getElementById('study_specimen') as HTMLSelectElement)?.selectedOptions;
    if (study_spec.length >= 2) {
        return_obj.study_specimen = "multiple";
        for (let n=0; n<study_spec.length; n++) {
            metadata.value[`internal_study_specimen_${n+1}`] = {
                key: `internal_study_specimen_${n+1}`,
                name: `Biospecimen ${n+1}`,
                value: study_spec[n].value
            }
        }
    } else {
        return_obj.study_specimen = (document.getElementById('study_specimen') as HTMLInputElement)?.value;
    }
    return_obj.study_metadata = metadata.value;
    return return_obj;
}

const getFiles = (): StudyFiles => {
    return {
        concentration_file: conc_file.value,
        metadata_file: metadata_file.value,
        phenotype_file: phenotype_file.value,
    }
}

const getParseParameters = (): ParseParameters => {
    let parseparams = {} as ParseParameters;
    if (pheno_transpose.value) parseparams.pheno_transpose = pheno_transpose.value;
    if (conc_transpose.value) parseparams.conc_transpose = conc_transpose.value;
    return parseparams;
}

const createThisStudy = () => {
    emit('create-study', getThisStudy(), getFiles(), getParseParameters());
}

const addMetadata = () => {
    let key = (document.getElementById('metadata_key') as HTMLInputElement)?.value
    let temp_metadata = {
        key: key,
        name: (document.getElementById('metadata_name') as HTMLInputElement)?.value,
        value: (document.getElementById('metadata_value') as HTMLInputElement)?.value,
    }
    metadata.value[key] = temp_metadata;
    currently_adding_metadata.value = false;
}

const removeMetadata = (metadata_key: string) => {
    delete metadata.value[metadata_key];
}

const logThis = (id: string) => {
    console.log((document.getElementById(id) as HTMLSelectElement)?.selectedOptions);
}

const setConcentrationFile = (e: Event): void => {
    e?.preventDefault();
    const target = e.target as HTMLInputElement;
    if (target.files) {
        conc_file.value = new File([target.files[0]], target.files[0].name);

    }
    else {
        conc_file.value = null;
    }
}

const setPhenotypeFile = (e: Event): void => {
    e?.preventDefault();
    const target = e.target as HTMLInputElement;
    if (target.files) {
        phenotype_file.value = new File([target.files[0]], target.files[0].name);

    }
    else {
        phenotype_file.value = null;
    }
}


const setMetadataFile = (e: Event): void => {
    e?.preventDefault();
    const target = e.target as HTMLInputElement;
    if (target.files) {
        metadata_file.value = new File([target.files[0]], target.files[0].name);

    }
    else {
        metadata_file.value = null;
    }
}

const setRawData = (e: Event): void => {
    e?.preventDefault();
    const target = e.target as HTMLInputElement;
    if (target.files) {
        raw_data.value = new File([target.files[0]], target.files[0].name);
    }
    else {
        raw_data.value = null;
    }
}


const currently_adding_metadata = ref<boolean>(false);
const alerts = ref({
    name: "",
    id: "",
    specimen: "",
    author: "",
    visibility: "",
    method: "",
    concfile: "",
    phenofile: "",
    rawfile: "",
    metafile: "",
    date: "",
});

const metadata = ref({} as MetadataObject);
const conc_file = ref<File|null>(null);
const raw_data = ref<File|null>(null);
const metadata_file = ref<File|null>(null);
const phenotype_file = ref<File|null>(null);
const conc_delimiter = ref<string>("semicolon");
const conc_transpose = ref<boolean>(false);
const pheno_delimiter = ref<string>("semicolon");
const pheno_transpose = ref<boolean>(false);
</script>

<style scoped>
.new-study-wrapper {
    min-width: 65%;
    width: 90%;
    max-width: 90%;
    padding: 1rem;
    background-color: #fff;
    margin: auto;
    box-shadow: var(--sd-larger);
    margin-top: 5.5rem;
}

input:invalid {
    border: red solid 2px;
    accent-color: red;
}
.new-study-grid {
    display: grid;
    grid-template-columns: 0.5fr 0.5fr;
    margin-top: 0.5rem;
    margin-bottom: 1rem;
}

input[type="file"] {
    max-width: 50ch;
}

.new-study-fields {
    display: grid;
    align-items: center;
    align-content: baseline;
    grid-template-columns: minmax(100px, 0.25fr) minmax(250px, 0.5fr) minmax(25px, 0.1fr);
    row-gap: 0.5rem;
    font-size: var(--fs-small);
}

.new-study-fields-right {
    display: grid;
    align-items: center;
    align-content: baseline;
    grid-template-columns: 1.5fr 2fr 2fr;
    row-gap: 0.5rem;
    font-size: var(--fs-small);
}

.span-grid {
    grid-column: 1 / 4;
    font-size: 0.65rem;
    color: #7a7a7a;
}

.span-grid-larger {
    grid-column: 1 / 4;
    font-size: var(--fs-default);
    color: var(--color-primary);
    margin-top: 0.5rem;
}

.headline {
    font-size: var(--fs-title);
    color: var(--color-primary);
    text-align: center;
    font-weight: bold;
}
.sub {
    color: var(--color-primary);
    font-size: var(--fs-large);
}

.lowercase {
    text-transform: lowercase;
}

.icon:hover {
    scale: 1.1 1.1;
    cursor: pointer;
}

@media (max-width: 1200px) {

.new-study-grid {
    grid-template-columns: 1fr;
    overflow-y: auto;
}

}

</style>
